package org.infinispan.upgrade;

import java.util.Arrays;
import java.util.Collections;
import javax.annotation.Generated;

import org.infinispan.factories.impl.ComponentAccessor;
import org.infinispan.factories.impl.ModuleMetadataBuilder;
import org.infinispan.factories.impl.MBeanMetadata;
import org.infinispan.factories.impl.MBeanMetadata.AttributeMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationParameterMetadata;
import org.infinispan.factories.impl.WireContext;
import org.infinispan.lifecycle.ModuleLifecycle;

/**
 * @private 
 */
@Generated(value = "org.infinispan.component.processor.Generator", date = "2020-03-16T14:08:45.261791Z")
public final class CorePackageImpl {
   public static void registerMetadata(ModuleMetadataBuilder.ModuleBuilder builder) {
//start org.infinispan.upgrade.RollingUpgradeManager
      builder.registerComponentAccessor("org.infinispan.upgrade.RollingUpgradeManager",
         Collections.emptyList(),
         new ComponentAccessor<RollingUpgradeManager>("org.infinispan.upgrade.RollingUpgradeManager",
            1, true, null,
            Arrays.asList("org.infinispan.Cache", "org.infinispan.commons.time.TimeService", "org.infinispan.configuration.global.GlobalConfiguration")) {
         protected void wire(RollingUpgradeManager instance, WireContext context, boolean start) {
            instance.cache = context.get("org.infinispan.Cache", org.infinispan.Cache.class, start);
            instance.timeService = context.get("org.infinispan.commons.time.TimeService", org.infinispan.commons.time.TimeService.class, start);
            instance.globalConfiguration = context.get("org.infinispan.configuration.global.GlobalConfiguration", org.infinispan.configuration.global.GlobalConfiguration.class, start);
         }

      });

      builder.registerMBeanMetadata("org.infinispan.upgrade.RollingUpgradeManager",
         MBeanMetadata.of("RollingUpgradeManager", "This component handles the control hooks to handle migrating data from one version of Infinispan to another", null,
            new OperationMetadata("synchronizeData", "", "Synchronizes data from the old cluster to this using the specified migrator", "long",
               new OperationParameterMetadata("migratorName", "java.lang.String", "The name of the migrator to use")
            ),
            new OperationMetadata("synchronizeData", "", "Synchronizes data from the old cluster to this using the specified migrator", "long",
               new OperationParameterMetadata("migratorName", "java.lang.String", "The name of the migrator to use"),
               new OperationParameterMetadata("readBatch", "int", "Numbers of entries transferred at a time from the old cluster"),
               new OperationParameterMetadata("threads", "int", "Number of threads per node used to write data to the new cluster")
            ),
            new OperationMetadata("disconnectSource", "", "Disconnects the target cluster from the source cluster according to the specified migrator", "void",
               new OperationParameterMetadata("migratorName", "java.lang.String", "The name of the migrator to use")
            )
      ));

//end
   }
}
